/*global define, ep*/
/*jslint nomen:true*/
define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!./otherbuttons-test.html',
    'jquery',

    './otherbuttons',
    '$ready!'
], function (QUnit, fixture, $) {
    'use strict';

    QUnit.module('de_epages/externalcontent/ui/otherbuttons', {
        setup: function () {
            fixture.init();
            ep.config = {
                storeRoot: '..',
                canonicalUrl: 'http://canonicalurl.com',
                webUrl: 'http://weburl.com'
            };
        },
        teardown: fixture.destroy
    });

    QUnit.test('Test otherbuttons methods', 2, function () {
        $.each(['_create', 'destroy'], function (i, fn) {
            QUnit.equal(
                $.isFunction($.ui.externalcontentUiOtherbuttons.prototype[fn]),
                true,
                fn + ' is a method of otherbuttons'
            );
        });
    });

    QUnit.test('Test otherbuttons', function () {
        // Setup of test options.
        var letters = ['A', 'B'],
            services = {
                A: ['digg', 'delicious', 'stumbleupon'],
                B: ['delicious']
            };

        // Create three *otherbuttons* gadgets.
        $.each(letters, function (index, value) {
            if (index === 1) {
                // Here we want to check whether the webUrl is used in case there is no canonicalUrl.
                ep.config.canonicalUrl = null;
            }

            $('div#' + value).externalcontentUiOtherbuttons({
                'services': services[value]
            });

            if (index === 1) {
                ep.config.canonicalUrl = 'http://canonicalurl.com';
            }
        });

        // Testing *_create*.
        $.each(letters, function (index, value) {
            var $gNode = $('div#' + value);

            QUnit.equal(
                $gNode.children().length,
                services[value].length,
                'Gadget #' + value + ' has the right number of bookmark buttons: $gNode.children().length'
            );

            $.each(services[value], function (_index, _value) {
                QUnit.equal(
                    $($gNode.children()[_index]).is('[href$="' + ((index !== 1) ? ep.config.canonicalUrl : ep.config.webUrl) + '"]'),
                    true,
                    'Gadget #' + value + '\'s *href* attribute ends with the right url:' + ((index !== 1) ? '*ep.config.canonicalUrl*' : '*ep.config.webUrl* (Fallback to *webUrl* works!)')
                );
            });
        });

        //Testing *destroy*.
        $('div#qunit-fixture div').each(function () {
            $(this).externalcontentUiOtherbuttons('destroy');

            QUnit.equal(
                $(this).children().length,
                0,
                'Destroy works. All *children* are gone.'
            );

            QUnit.equal(
                $(this).attr('class'),
                '',
                'Destroy works. CSS classes added by the gadget were removed.'
            );
        });
    });
});