/*global define,window*/
define([
    'testsuite/qunit',
    'jquery',
    'ep',
    'testsuite/qunit-fixture!./packlinkuninstallapp-test',
    'de_epages/packlink/ui/packlinkuninstallapp'
], function(QUnit, $, ep, fixture, packlinkuninstallapp) {

    'use strict';
    QUnit.module('de_epages/packlink/ui/packlinkuninstallapp', {
        setup: fixture.init,
        teardown: fixture.destroy
    });
//
    QUnit.test('Uninstall app behaviour check on uninstall from Packlink Settings page', 3, function() {

        ep.ajax = function(o) {
            var result = $.Deferred();

            result.resolve({
                "status": "ok",
                "message": "",
                "redirectUrl": ""
            });

            return result;
        };

        // Mocking the window to avoid the reload
        this.mockWindow = {
            location: {
                reload: function() {
                    ok(true, "Window reload is called as a result of ajax returning a zero length URL");
                }
            }
        };

        var UninstallAppButton = $('#PacklinkCanConnect');
        var div = $(".uiDialogButtonPane");
        packlinkuninstallapp( UninstallAppButton, div, "12345", this.mockWindow );

        UninstallAppButton.trigger('click');
        $('#YesId').trigger('click');

        QUnit.strictEqual(
                $("#Response").html(),
                'OK',
                'Check that the value of the dialog is the expected for a properly execution. We are waiting for the word OK at the dialog'
        );

        QUnit.ok(
                $("#CloseButtonForPacklink"),
                'Check that the close button exists'
        );
    });
    QUnit.test('Uninstall app behaviour check on uninstall from App Store page ', 1, function() {

        ep.ajax = function(o) {
            var result = $.Deferred();

            result.resolve({
                "status": "ok",
                "message": "",
                "redirectUrl": "http://test.com"
            });

            return result;
        };
        
        // Mocking the window to avoid the redirection
        this.mockWindow = {
            location: {
                assign: function() {
                    ok(true, "Window gets re-assigned as a result of ajax returning a non zero length URL");
                }
            }
        };
        var UninstallAppButton = $('#PacklinkCanConnect');
        var div = $(".uiDialogButtonPane");
        packlinkuninstallapp( UninstallAppButton, div, "12345", this.mockWindow );

        UninstallAppButton.trigger('click');
        $('#YesId').trigger('click');
    })
});